// *******************************************************
// *                                                     *
// *    JAVA  APPLIKATION:   KippKickControl             *
// *                                                     *
// *    Steuerung des KHM KippKickers                    *
// *       + class KippKick                              *
// *       + Kamera Tracking (onScreen)                  *
// *                                                     *
// *******************************************************
// *                                                     *
// *     CodeKit:    author  Jochen Viehoff              *
// *                                                     *
// *******************************************************

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class KippKickControl extends JFrame implements Runnable{
    
    int delay = 1000;                             //  delay time
    
    int threshold = 10;                            //  tolerance
    int tolerance = 100;
    int pointX [] = {740,773,961,1001};             //  capture areas x coordinates
    int pointY [] = {570,670,570,670};             //  capture areas y coordinates
    int dimX      = 1024;                           //  size of capture areas
    int dimY      = 768;
    
    int countA,countB;
    
    int pixelInitA [][] = new int[dimX][dimY];
    int pixelInitB [][] = new int[dimX][dimY];
    int pixelA     [][] = new int[dimX][dimY];
    int pixelB     [][] = new int[dimX][dimY];
    
    Robot           captureRobot;                  // Robot object for screen capture
    Thread          captureThread;
    
    KippKick      myKick;                         // table control with labpro
    
    //  ******************************************
    //     main method:
    //  ******************************************
    
    public static void main(String[] args) {
        
        KippKickControl myControl = new KippKickControl();
    }
    
    //  ******************************************
    //       constructor
    //  ******************************************
    
    public KippKickControl() {
        
        // start labpro control
        KippKick myKick = new KippKick();
        
        // start control robot
        try { captureRobot = new Robot(); }
        catch(AWTException awte) {System.out.println(awte);}
        
        // start capture thread
        captureThread = new Thread(this);
        captureThread.start();
    }
    
    public void paint(Graphics g) {
    }
    // ****************************************************
    //   captureThread: run method
    // ****************************************************
    
    public void run() {
        
        // get init screen capture
        initScreenCapture();
        
        while (captureThread != null ) {
            
            countA = 0;
            countB = 0;
            
            // get screen capture
            // area A
            for (int x=pointX[0];x<pointX[1];x++){
                for (int y=pointY[0];y<pointY[1];y++){
                    pixelA[x][y] = captureRobot.getPixelColor(x,y).getRed();
                    if (Math.abs(pixelA[x][y]-pixelInitA[x][y])>threshold)
                        countA++;
                }
            }
            // area B
            for (int x=pointX[2];x<pointX[3];x++){
                for (int y=pointY[2];y<pointY[3];y++){
                    pixelB[x][y] = captureRobot.getPixelColor(x,y).getRed();
                    if (Math.abs(pixelB[x][y]-pixelInitB[x][y])>threshold)
                        countB++;
                }
            }
            // sleep for a while
            try {Thread.sleep(delay);}
            catch (InterruptedException e) {}
            
            System.out.println(countA+"  "+countB);
            
            if ((countA-countB)> tolerance)
                myKick.moveUp();
            if ((countA-countB)<-tolerance)
                myKick.moveDown();
            if (Math.abs(countA-countB)<tolerance)
                myKick.release();
        }
    }
    
    // ****************************************************
    //   public method: initScreenCapture
    // ****************************************************
    
    public void initScreenCapture(){
        for (int x=pointX[0];x<pointX[1];x++){
            for (int y=pointY[0];y<pointY[1];y++){
                pixelInitA[x][y] = captureRobot.getPixelColor(x,y).getRed();
            }
        }
        // area B
        for (int x=pointX[2];x<pointX[3];x++){
            for (int y=pointY[2];y<pointY[3];y++){
                pixelInitB[x][y] = captureRobot.getPixelColor(x,y).getRed();
            }
        }
        
    }
}

//  ******************************************

//  ******************************************
