//    ******************************************
//        class PlayCourt
//
//        captures RGB screen pixel
//
//             author: jochen viehoff
//
//    ******************************************

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class PlayCourt extends JFrame implements Runnable {
    
    int myID = 0;                                  // id for multicast server
    int numPoints = 4;                             // number of points
    int delay = 50;                                //  delay time
    
    int threshold = 20;                          //  tolerance
    int pointX [] = {861,789,858,854};             //  capture points x coordinates
    int pointY [] = {543,610,685,622};             //  capture points y coordinates
    
    int pixelInit  [] = new int[numPoints];
    int pixelColor [] = new int[numPoints];
    
    Robot           captureRobot;                  // Robot object for screen capture
    Thread          captureThread;
    MultiCastServer myServer;
    BufferedImage buffer;
    //  ******************************************
    //     main method:
    //  ******************************************
    
    public static void main(String[] args) {
        
        PlayCourt myCourt = new PlayCourt();
//        myCourt.show();
    }
    
    //  ******************************************
    //       constructor
    //  ******************************************
    
    public PlayCourt() {
        
        // start MultiCastServer
        MultiCastServer myServer = new MultiCastServer(myID);
        
        // start control robot
        try { captureRobot = new Robot(); }
        catch(AWTException awte) {System.out.println(awte);}
        
        captureThread = new Thread(this);
        captureThread.start();
    }
    public void paint(Graphics g) {
        g.drawImage(buffer,0,0,this);
    }
    // ****************************************************
    //   captureThread: run method
    // ****************************************************
    
    public void run() {
        
        // get init screen capture
        pixelInit[0]     = captureRobot.getPixelColor(pointX[0],pointY[0]).getRed();
        pixelInit[1]     = captureRobot.getPixelColor(pointX[1],pointY[1]).getRed();
        pixelInit[2]     = captureRobot.getPixelColor(pointX[2],pointY[2]).getRed();
        pixelInit[3]     = captureRobot.getPixelColor(pointX[3],pointY[3]).getRed();
        
        while (captureThread != null ) {
            
            // get screen capture
            pixelColor[0]     = captureRobot.getPixelColor(pointX[0],pointY[0]).getRed();
            pixelColor[1]     = captureRobot.getPixelColor(pointX[1],pointY[1]).getRed();
            pixelColor[2]     = captureRobot.getPixelColor(pointX[2],pointY[2]).getRed();
            pixelColor[3]     = captureRobot.getPixelColor(pointX[3],pointY[3]).getRed();
            
//           buffer = captureRobot.createScreenCapture(new Rectangle(700,600,800,700));
//          repaint();
//           System.out.println(pixelColor[0]);
            // sleep for a while
            try {Thread.sleep(delay);}
            catch (InterruptedException e) {}
            myServer.update(0.0f,0.0f);
 
            if (Math.abs(pixelColor[0]-pixelInit[0])>threshold)
                myServer.update(1.0f,0.0f);
             if (Math.abs(pixelColor[1]-pixelInit[1])>threshold)
                myServer.update(2.0f,0.0f);
             if (Math.abs(pixelColor[2]-pixelInit[2])>threshold)
                myServer.update(3.0f,0.0f);
             if (Math.abs(pixelColor[3]-pixelInit[3])>threshold)
                myServer.update(4.0f,0.0f);
            
        }
    }
}

//  ******************************************
//  ******************************************
