//    ******************************************
//         Class: RemoteControl
//
//         generates mouse/key events
//         received from multicast server
//
//         (remote)   game interface
//
//         author: jqochen viehoff
//
//    ******************************************

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RemotePacman  implements Runnable {
    
    int serverID = 0;
    int delay    = 50;
    float f2=0.0f,f1Old,f2Old,f1     = 0.0f;
    
    Robot  controlRobot;
    Thread controlThread;
    
    MultiCastClient controlClient;
    
    // ****************************************************
    //   main method
    // ****************************************************
    
    public static void main(String[] args) {
        
        RemotePacman myControl = new RemotePacman();
    }
    
    // ****************************************************
    //   constructor
    // ****************************************************
    
    public RemotePacman() {
        
        MultiCastClient controlClient = new MultiCastClient();
        
        try { controlRobot = new Robot(); }
        catch(AWTException awte) {System.out.println(awte);}
        
        controlThread = new Thread(this);
        controlThread.start();
        
    }
    // ****************************************************
    //   controlThread: run method
    // ****************************************************
    
    public void run() {
        
        while (controlThread != null ) {
            
            f1Old = f1;
            f2Old = f2;
            // get control number from MultiCastServer
            f1=controlClient.getFloat1(serverID);
            f2=controlClient.getFloat2(serverID);
            
            // generate key event corresponding to control number
            if (f1Old!=f1){
                if (f1==2.0f) controlRobot.keyPress(KeyEvent.VK_Y);
                if (f1==1.0f) controlRobot.keyPress(KeyEvent.VK_N);
                if (f1==4.0f) controlRobot.keyPress(KeyEvent.VK_G);
                if (f1==3.0f) controlRobot.keyPress(KeyEvent.VK_J);
            }
            // sleep for a while
            try {Thread.sleep(delay);}
            catch (InterruptedException e) {}
            
            // release key
            if (f1Old!=f1){
                controlRobot.keyRelease(KeyEvent.VK_LEFT);
                controlRobot.keyRelease(KeyEvent.VK_RIGHT);
                controlRobot.keyRelease(KeyEvent.VK_UP);
                controlRobot.keyRelease(KeyEvent.VK_DOWN);
            }
        }
    }
    
}
