// *******************************************************
// *                                                     *
// *    JAVA  APPLIKATION:   TheLine                     *
// *                                                     *
// *     La Linea - interaktiv                           *
// *                                                     *
// *     Idee: Mone Kante (2001)                         *
// *                                                     *
// *******************************************************
// *                                                     *
// *     CodeKit:    author  Jochen Viehoff              *
// *                                                     *
// *******************************************************

import java.awt.*;
import java.awt.event.*;

import quicktime.std.*;                        //  Quicktime for JAVA
import quicktime.qd.*;                         //  Liberies werden benoetigt
import quicktime.QTObject.*;
import quicktime.*;
import quicktime.util.QTUtils;

import quicktime.std.StdQTConstants;
import quicktime.std.sg.*;
import quicktime.std.sg.VisualChannel;
import quicktime.app.sg.SGDrawer;
import quicktime.util.*;
import quicktime.util.QTPointerRef.*;
import quicktime.app.display.QTCanvas;
import quicktime.std.comp.*;
import quicktime.std.comp.Component;
import quicktime.app.QTFactory.*;
import quicktime.app.display.*;
import quicktime.app.image.*;
import quicktime.app.image.ImageDrawer;
import quicktime.util.QTByteObject;

public class TheLine  extends Frame implements Runnable,StdQTConstants,MouseListener,MouseMotionListener,KeyListener {
    
    
    public final short N       = 2400;                //  Anzahl der Kugeln
    public final short fact    = 6;
    
    public final float a[]     = new float [3],       // Konstanten fuer die Integration
    b[]     = new float [3];
    
    
    private float lineX []     = new float [N];       // Koordinaten der Linie
    private float lineY []     = new float [N];
    
    private short pixelX []    = new short [N];       // Pixel-Koordinaten
    private short pixelY []    = new short [N];
    
    private float veloX []     = new float [N];       // Geschwindigkeiten
    private float veloY []     = new float [N];
    
    private float forceX []    = new float [N];       // Kraefte
    private float forceY []    = new float [N];
    
    private short shapeX[]     = new short[N];        // Felder fuer Umriss
    private short shapeY[]     = new short[N];
    private short shapeSortX[] = new short[N];
    private short shapeSortY[] = new short[N];
    private short ShapeX[]     = new short[N];
    private short ShapeY[]     = new short[N];
    
    private float mass         = 1.0f;                // interne Federkraft
    private float upForce      = 4.0f;                // Staerke des Kraftfeldes
    private float backForce    = 2.0f;                // Rueckstellkraft
    private float dt           = 0.5f;                // Zeitschritt
    
    private int contrast       = 63530;               // Empfindlichkeit fuer Video-Grab (Schwellwert)
    
    private float initX[]      = new float[N];        // Ruhezustand der Linie
    private float initY[]      = new float[N];
    
    private short length;
    private short lineWidth    = 10;                  // Linienbreite
    private short ballSize     = 1;                   // Groesse der Kugeln
    
    final short baseLine       = 380;                 // Grundhoehe
    
    final int delayAnim        = 500;                   // Animationsgeschwindigkeit
    
    final int centerX          = 200;                 // Koordinaten des Displays
    final int centerY          = 100;
    
    final int sizeX            = 400;                 // Groesse des Displays
    final int sizeY            = 400;
    
    final short grabSizeX      = 100;                 //Groesse des Videobildes
    final short grabSizeY      = 100;
    
    Color ballColor            = Color.black;         // Farbe  des Kugeln
    Color bgColor              = Color.white;         // Hintergrundfarbe
    
    private Thread lineThread;                        // Thread fuer die Animation
    
    Image     buffer;
    Pict      pic;
    Graphics  bg;
    
    boolean extern=true;
    
    int [][] pixel = new int [grabSizeX][grabSizeY];
    
    QDRect          myQDRect = new QDRect(grabSizeX,grabSizeY);
    QDGraphics      myQDGraphics;
    QDColor         pixelColor = QDColor.black;
    SequenceGrabber myGrabber;
    
    Drawable        myQTContent;                     // Quicktime Variable
    QTCanvas        myQTCanvas;
    SGDrawer        mySGDrawer;
    SGVideoChannel  myVideo;
    
    //    ******************************************
    //      main method in TheLine
    //    ******************************************
    
    public static void main(String[] args) {
        
        TheLine myLine = new TheLine();
        
    }
    // ****************************************************
    //    Konstruktor
    // ****************************************************
    
    public TheLine() {

        setBackground(bgColor);    	                 // Aktivieren der Eventlistener
        addMouseListener(this);
        addMouseMotionListener(this);
        addKeyListener(this);
        
        a[0] =  7.0f/24.0f;                         // Konstanten fuer die Integration
        a[1] =  3.0f/4.0f;
        a[2] = -1.0f/24.0f;
        b[0] =  2.0f/3.0f;
        b[1] = -2.0f/3.0f;
        b[2] =  1.0f;
        
        for (short i=0;i<N;i++) {                   // Initialisierung der Koordinatenfelder
            lineX[i]=(float)(i/fact);
            lineY[i]=baseLine;
            ShapeX[i]=(short)(i/fact);
            ShapeY[i]=baseLine;
            initX[i]=(float)(i/fact);
            initY[i]=baseLine;
        }
        
        try {                                      // Quicktime Initialisierung
            QTSession.open();
            setLayout(new BorderLayout());
            
            myQTCanvas = new QTCanvas();
            myQTCanvas.setSize(new Dimension(grabSizeX,grabSizeY));
            myQTCanvas.setMaximumSize(grabSizeX+10,grabSizeY+10);
            add(myQTCanvas, "Center");
            addNotify();
            Insets insets = getInsets();
            setBounds(0, 0, (insets.left + insets.right + grabSizeX), (insets.top + insets.bottom + grabSizeY));
            myQDGraphics = new QDGraphics(myQDRect);
            myGrabber    = new SequenceGrabber();
            SGVideoChannel  myVideo  =new SGVideoChannel(myGrabber);
            
            myVideo.settingsDialog();
            myVideo.setBounds(myQDRect);
            myVideo.setVideoRect(myQDRect);
            myVideo.setUsage(seqGrabPreview);
            mySGDrawer = new SGDrawer(myVideo);
            
            pack();
            show();
            setSize(600,400);
            toFront();
            
            
            
        }
        catch (Exception e) {
            e.printStackTrace();
            QTSession.close();
        }
        
        
        if (lineThread == null) {                        // Start AnimationsThread
            lineThread = new Thread(this);
            lineThread.start();
        }
        try {
            if (myQTCanvas != null) {                    // Start Sequence Grabber
                myQTCanvas.setClient(mySGDrawer, true);
                myGrabber.prepare(true,false);
                myGrabber.startPreview();
                myQTCanvas.setVisible(true);
                myQDGraphics = myQTCanvas.getPort();
            }
        }
        catch (QTException e) {
            e.printStackTrace();
        }
    }
    
    
    // ****************************************************
    //    Thread: Run Methode
    // ****************************************************
    
    public void run() {
        
        while(lineThread != null) {
            
            try {                                         // get Pixel
                for (short y=0;y<grabSizeY;y++) {
                    for (short x=0;x<grabSizeX;x++) {
//                        pixelColor=myQDGraphics.getCPixel(x,y);
                        pixel[x][y] = pixelColor.getBlue();
                    }
                }
            }
            
            catch (Exception e) {
                e.printStackTrace();
                QTSession.close();
            }
            
            System.out.println(pixel[50][50]);
            grabPixel();
            
            try {                                         // Wait
                lineThread.sleep(delayAnim);
            }
            catch(InterruptedException e) {}
            
            repaint();
        }
        
        lineThread = null;
        
    }
    
    // ****************************************************
    //   Ueberschreiben der update-Methode
    // ****************************************************
    
    public void update(Graphics g){
        paint(g);
    }
    
    // ****************************************************
    //   Ueberschreiben der paint-Methode
    // ****************************************************
    
    public void paint(Graphics g){
        
        buffer = createImage(sizeX+1,sizeY+1);
        bg     = buffer.getGraphics();
        
        bg.setColor(bgColor);                           // Farbe der Kugeln
        bg.drawRect(0,0,400,400);
        for (short i=1;i<N-1;i++) {
            //			bg.fillOval(pixelX[i],pixelY[i],ballSize,ballSize);
            //			bg.fillOval(ShapeX[i],ShapeY[i],ballSize,ballSize);
            //			bg.fillOval(shapeX[i],shapeY[i],ballSize,ballSize);
            //			bg.drawLine(pixelX[i-1],pixelY[i-1],pixelX[i],pixelY[i]);
            bg.drawLine(ShapeX[i-1],ShapeY[i-1],ShapeX[i],ShapeY[i]);
            //			bg.drawLine(shapeSortX[i-1],shapeSortY[i-1],shapeSortX[i],shapeSortY[i]);
        }
        
        iterate();                                     // Integration
        getScreenCoords();                              // Pixel Koordinaten
        grabPixel();
        
        bg.setColor(ballColor);                         // Farbe der Kugeln
        for (short i=1;i<N-1;i++) {
            //			bg.fillOval(pixelX[i],pixelY[i],ballSize,ballSize);
            //			bg.fillOval(ShapeX[i],ShapeY[i],ballSize,ballSize);
            //			bg.fillOval(shapeX[i],shapeY[i],ballSize,ballSize);
            // 	    	bg.drawLine(pixelX[i-1],pixelY[i-1],pixelX[i],pixelY[i]);
            bg.drawLine(ShapeX[i-1],ShapeY[i-1],ShapeX[i],ShapeY[i]);
            //			bg.drawLine(shapeSortX[i-1],shapeSortY[i-1],shapeSortX[i],shapeSortY[i]);
        }
        bg.drawRect(0,0,sizeX,sizeY);
        bg.dispose();
        
        g.drawImage(buffer,centerX,centerY,null);
    }
    
    // ****************************************************
    //   Berechnung der Pixel-Koordinaten
    // ****************************************************
    
    public void getScreenCoords() {
        
        for (short i=0;i<N;i++) {
            pixelX[i] = (short)(lineX[i]);
            pixelY[i] = (short)(lineY[i]);
        }
    }
    
    // ****************************************************
    //   Berechnung der Kraefte
    // ****************************************************
    
    public void getForces() {
        
        for (short i=1;i<N-1;i++) {
            if (extern) {
                forceX[i] = mass*(lineX[i-1]+lineX[i+1]-2.0f*lineX[i])+upForce*(ShapeX[i]-lineX[i]);
                forceY[i] = mass*(lineY[i-1]+lineY[i+1]-2.0f*lineY[i])+upForce*(ShapeY[i]-lineY[i]);
            }
            else {
                forceX[i] = -mass*backForce*(lineX[i]-initX[i]);
                forceY[i] = -mass*backForce*(lineY[i]-initY[i]);
            }
        }
    }
    
    // ****************************************************
    //   Integration: symplektisch 3. Ordnung
    // ****************************************************
    
    public void iterate() {
        
        for (short k=0;k<3;k++) {
            for (short i=10;i<N-10;i++) {
                lineX[i] += a[k]*dt*veloX[i];
                lineY[i] += a[k]*dt*veloY[i];
            }
            
            getForces();		                         // Berechnung der neuen Kraefte
            
            for (short i=10;i<N-10;i++) {
                veloX[i] = b[k]*dt*forceX[i];
                veloY[i] = b[k]*dt*forceY[i];
            }
        }
    }
    // ****************************************************
    //   PixelGrabbing
    // ****************************************************
    
    public void grabPixel() {
        
        boolean tracking = true;
        length = 0;
        shapeX[0] = 0;
        shapeY[0] = grabSizeY-1;
        
        for (short y=1;y<grabSizeY-1;y++) {
            for (short x=1;x<grabSizeX-1;x++) {
                
                if (pixel[x][y]<contrast && tracking) {
                    shapeX[length]=(short)x;
                    shapeY[length]=(short)y;
                    tracking=false;
                    length++;
                }
                if (pixel[x][y]>contrast && !tracking) {
                    shapeX[length]=(short)x;
                    shapeY[length]=(short)y;
                    tracking=true;
                    length++;
                }
            }
            tracking=true;
        }
        
        for (short x=1;x<grabSizeX-1;x++) {
            for (short y=1;y<grabSizeY-1;y++) {
                
                if (pixel[x][y]<contrast && tracking) {
                    shapeX[length]=(short)x;
                    shapeY[length]=(short)y;
                    tracking=false;
                    length++;
                }
                if (pixel[x][y]>contrast && !tracking) {
                    shapeX[length]=(short)x;
                    shapeY[length]=(short)y;
                    tracking=true;
                    length++;
                }
            }
            
            if (tracking) {
                shapeX[length]=(short)x;
                shapeY[length]=(short)grabSizeY-1;
                length++;
            }
            tracking = true;
        }
        
        //		shapeX[length]=(short)grabSizeX-1;
        //		shapeY[length]=(short)grabSizeY-1;
        
        //		sort();                  // Umsortieren der Pixel!!!!!
        
        for (short i=0;i<N;i++) {
            ShapeX[i]=(short)(4*shapeX[(int)(i*length/(N-1))]+(Math.random()-0.5)*lineWidth);
            ShapeY[i]=(short)(4*shapeY[(int)(i*length/(N-1))]+(Math.random()-0.5)*lineWidth-16);
            
        }
    }
    
    // ****************************************************
    //   Sorting
    // ****************************************************
    
    public void sort() {
        
        short tmp1=0,tmp2=0,i;
        float dist = 0.0f;
        float minDist;
        boolean found;
        boolean take [] = new boolean[N];
        
        take[0]         = true;
        
        i=0;
        
        for (int j=0;j<N;j++){
            shapeSortX[j]=(short)(j*grabSizeX/(N-1));
            shapeSortY[j]=grabSizeY-1;
        }
        
        while (tmp1<length-1) {
            tmp1=i;
            minDist=50.0f;
            found=false;
            for (short j=0;j<length;j++) {
                if (!take[j]) {
                    dist=(shapeX[tmp2]-shapeX[j])*(shapeX[tmp2]-shapeX[j])
                    +(shapeY[tmp2]-shapeY[j])*(shapeY[tmp2]-shapeY[j]);
                    if (dist<minDist) {
                        minDist=dist;
                        tmp1=j;
                        found=true;
                    }
                }
            }
            if (found) {
                shapeSortX[i+1]=shapeX[tmp1];
                shapeSortY[i+1]=shapeY[tmp1];
                take[tmp1]=true;
                tmp2=tmp1;
            }
            i++;
        }
        
    }
    
    
    // ****************************************************
    //   Mouse Events
    // ****************************************************
    
    public void mousePressed(MouseEvent e)   {}
    public void mouseReleased(MouseEvent e)  {}
    
    public void mouseClicked(MouseEvent e)  {
        extern=!extern;
    }
    
    public void mouseEntered(MouseEvent e)  {}
    public void mouseExited(MouseEvent e)   {}
    public void mouseDragged(MouseEvent e)  {}
    public void mouseMoved(MouseEvent e)    {}
    
    // ****************************************************
    //   KeyEvents
    // ****************************************************
    
    public void keyPressed(KeyEvent evt)  {
        
        int keyCode;
        keyCode = evt.getKeyCode();
        if (keyCode==KeyEvent.VK_F1)
            mass++;
        if (keyCode==KeyEvent.VK_F2)
            mass--;
        if (keyCode==KeyEvent.VK_F3)
            upForce++;
        if (keyCode==KeyEvent.VK_F4)
            upForce--;
        if (keyCode==KeyEvent.VK_F5)
            dt=dt+0.05f;
        if (keyCode==KeyEvent.VK_F6)
            dt=dt-0.05f;
        if (keyCode==KeyEvent.VK_F7)
            ballSize++;
        if (keyCode==KeyEvent.VK_F8)
            ballSize--;
        if (keyCode==KeyEvent.VK_F9)
            lineWidth++;
        if (keyCode==KeyEvent.VK_F10)
            lineWidth--;
        if (keyCode==KeyEvent.VK_F11)
            backForce++;
        if (keyCode==KeyEvent.VK_F12)
            backForce--;
        if (keyCode==KeyEvent.VK_TAB) {
            dt = 0.3f;
            mass=15.0f;                         // Kritische Paramater !!
            upForce=4.0f;
        }
        if (keyCode==KeyEvent.VK_ESCAPE) {
            for (short i=0;i<N;i++) {
                lineX[i]=(float)(i/fact);
                lineY[i]=baseLine;
                ShapeX[i]=(short)(i/fact);
                ShapeY[i]=baseLine;
            }
            dt=0.3f;                            // Reset Line
            mass=2.0f;
            upForce=12.0f;
            backForce=2.0f;
        }
    }
    public void keyReleased(KeyEvent evt) {}
    public void keyTyped(KeyEvent evt)    {}
}
// ******************************************************
// ******************************************************
